/*
package com.example.ReactiveWebFlux;

import org.assertj.core.api.Assertions;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.reactive.server.WebTestClient;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.test.StepVerifier;

import java.time.LocalDateTime;

import static org.junit.Assert.assertEquals;
import static org.mockito.ArgumentMatchers.any;
import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.when;
@RunWith(SpringRunner.class)
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.DEFINED_PORT, classes = ReactiveWebFluxApplication.class)
@ActiveProfiles("integration")
public class UserControllerIntegrationTest {
    @Mock
    private UserRepository userRepository;

    @Autowired
    private WebTestClient webTestClient;
    final private static int port = 8888;
    final private static String baseUrl = "http://localhost:8888";
    @Test
    public void saveUserTest () {

        User UserResponse =   webTestClient.post().uri(baseUrl+"/user/create")
                .body(Mono.just(getUser()), User.class)
                .exchange()
                .expectStatus().isOk()
                .expectBody(User.class)
                .returnResult()
                .getResponseBody();
        StepVerifier.create(Flux.just(UserResponse))
                .expectNextMatches(e-> e.getName().equals("praneeth")
                ).verifyComplete();

    }

    private User getUser () {
        User user = new User();
        user.setEmail("praneeth@gmail.com");
        user.setName("praneeth");
        return user;
    }
    @Test
    public void testGetUserById () {
*/
/*
        User user = new User("5ebbac8c470a341gh872cf3", "Adi", "adu@gmail.com", LocalDateTime.now());

        when(userService.getUserById(anyString())).thenReturn(Mono.just(user));*//*

        webTestClient.get().uri("/user/5ebbac8c470a341gh872cf3")
                .exchange()
                .expectStatus().isOk()
                .expectBody(User.class)
                .consumeWith(resp -> {
                    if (resp.getResponseBody() != null) {
                        assertEquals("Adi", resp.getResponseBody().getName());
                    }
                });
    }

    @Test
    public void testGetUsers () {

     */
/*   User user1 = new User("1", "ABC", "abc@xyz.com", LocalDateTime.now());
        User user2 = new User("2", "XYZ", "xyz@xyz.com", LocalDateTime.now());

        when(userService.getUsers()).thenReturn(Flux.just(user1, user2));*//*


        webTestClient.get()
                .uri("/user")
                .exchange()
                .expectStatus().isOk()
                .expectBodyList(User.class)
                .value(userResponse -> {
                           Assertions.assertThat(userResponse.get(0).getId()).isEqualTo("1");
                           Assertions.assertThat(userResponse.get(0).getName()).isEqualTo("ABC");
                           Assertions.assertThat(userResponse.get(0).getEmail()).isEqualTo("abc@xyz.com");
                           Assertions.assertThat(userResponse.get(1).getId()).isEqualTo("2");
                           Assertions.assertThat(userResponse.get(1).getName()).isEqualTo("XYZ");
                           Assertions.assertThat(userResponse.get(1).getEmail()).isEqualTo("xyz@abc.com");
                       }
                );
    }
}
*/
