package com.example.demo.Repository;

import com.example.demo.model.Employee;
import com.example.demo.model.Error;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.util.List;

@Service
public class EmployeeServiceImpl implements EmployeeService {
    @Autowired
    EmployeeRepository employeeRepository;

    public EmployeeServiceImpl ( EmployeeRepository employeeRepository ) {
        this.employeeRepository = employeeRepository;
    }

    @Override
    public Mono<Employee> findEmployeeById ( String Id ) {
        return employeeRepository.findById(Id);
    }

    private Mono<Employee> generateError () {

        Employee employee = new Employee();
        Error error = new Error("E100", "Employee NotFound With given ID", "record not there in db");
        employee.setError(error);
        return Mono.just(employee);
    }

    @Override
    public Mono<List<Employee>> findAll () {
        return employeeRepository.findAll().collectList();
    }

    @Override
    public Mono<Employee> save ( Employee employee ) {
        return employeeRepository.save(employee);
    }

    @Override
    public Mono<Void> delete ( Employee employee ) {
        return employeeRepository.delete(employee);
    }

    @Override
    public Flux<Employee> saveAll ( Flux<Employee> entities ) {
        return employeeRepository.saveAll(entities);
    }

    @Override
    public Mono<Void> deleteById ( String id ) {
        return employeeRepository.deleteById(id);
    }
}
